SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest methodsFor: 'Books' stamp: 'BarroumeresLaje 6/10/2012 16:14'!
libro100MasDeUnSigloRojoYBlanco

	^'9789507543340'



! !

!TusLibrosTest methodsFor: 'Books' stamp: 'BarroumeresLaje 6/10/2012 16:16'!
libroLTA

	^'9789876480390'



! !

!TusLibrosTest methodsFor: 'Books' stamp: 'BarroumeresLaje 6/10/2012 16:13'!
libroSerDeRiver

	^'9789500737111'



! !

!TusLibrosTest methodsFor: 'TusLibros Entities' stamp: 'BarroumeresLaje 6/10/2012 17:22'!
newCart

	^Bag  new.
! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/10/2012 15:53'!
test01CartShouldBeEmptyWhenCreated


	self assert: self newCart  isEmpty.
	! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/10/2012 17:26'!
test02AddToCartAddTheCorrectAmountOfBooksToTheCart

	|aCart|
	aCart := self newCart.
	
	self assert: (aCart occurrencesOf: self libroSerDeRiver) = 0.
	aCart add: self libroSerDeRiver withOccurrences: 10.
	self assert: (aCart occurrencesOf: self libroSerDeRiver) = 10! !

!TusLibrosTest methodsFor: '1 - Cart manipulation' stamp: 'BarroumeresLaje 6/10/2012 22:09'!
test03CannotAddBooksFromAnotherPublisherToCart

	"Adding an item which is not in the catalogue should raise a NotFound exception"

	|catalogue|
	catalogue:=self tusLibrosEmptyCatalogue.
	catalogue add: self libro100MasDeUnSigloRojoYBlanco.
	catalogue add: self libroSerDeRiver.
	
	self should: [ self newCart add: (catalogue item: self libroLTA)] raise: NotFound.
	
! !

!TusLibrosTest methodsFor: 'TusLibros Entities' stamp: 'BarroumeresLaje 6/10/2012 22:07'!
tusLibrosEmptyCatalogue


	^ShopCatalogue  new! !

Object subclass: #ShopCatalogue
	instanceVariableNames: 'itemsInStore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!ShopCatalogue methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/10/2012 21:56'!
add: anItem 

	itemsInStore add: anItem! !

!ShopCatalogue methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/10/2012 21:49'!
initialize 

	itemsInStore:=Set new.! !

!ShopCatalogue methodsFor: 'as yet unclassified' stamp: 'BarroumeresLaje 6/10/2012 22:10'!
item: anItem


	(itemsInStore includes: anItem) ifTrue: [^anItem] ifFalse: [^ValueNotFound signal: 'Este item no esta a la venta'].
	! !
